using System;
using System.Collections.Generic;
using System.Text;

namespace HalaviGrocery
{
    /// <summary>
    /// <h3 dir="rtl" style="color:red; font-family: Helvetica, Arial, sans-serif">
    ///       FIFO    .
    /// </h3>
    /// </summary>
    /// <author>   ,   ,  ,  </author>
    /// <version> 12.11.2007 </version>
    /// <typeparam name="T">    </typeparam>
    public class Queue<T>
    {
        private List<T> data;	 //     
        private Node<T> lastPos; // (   ( 

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b> 
        ///    
        /// </b>
        /// </summary>
        public Queue()
        {
            this.lastPos = null;
            this.data = new List<T>();
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///   ''    , '' 
        /// </b>
        /// </summary>
        /// <returns> ``    , ``  </returns>
        public bool IsEmpty()
        {
            return (this.data.IsEmpty());
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///     x   
        /// </b>
        /// </summary>
        /// <param name="x">     </param>
        public void Insert(T x)
        {
            this.lastPos = this.data.Insert(this.lastPos, x);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///         
        /// <br/><u>:</u>    
        /// </b>
        /// </summary>
        /// <returns>    </returns>
        public T Remove()
        {
            if (this.lastPos == this.data.GetFirst())
                this.lastPos = null;
            T x = this.data.GetFirst().GetInfo();
            this.data.Remove(this.data.GetFirst());
            return (x);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///          
        /// <br/><u>:</u>    
        /// </b>
        /// </summary>
        /// <returns>      </returns>
        public T Head()
        {
            return (this.data.GetFirst().GetInfo());
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///         ,  (x1    ):
        /// [x1,x2,...,xn]
        /// </b>
        /// </summary>
        /// <returns>     </returns>
        public override string ToString()
        {
            Node<T> pos = this.data.GetFirst();

            string str = "[";
            while (pos != null)
            {
                str = str + pos.GetInfo().ToString();
                if (pos.GetNext() != null)
                    str = str + ",";
                pos = pos.GetNext();
            }
            str = str + "]";

            return (str);
        }
    }
}
