using System;
using System.Collections.Generic;
using System.Text;

namespace HalaviGrocery
{
    /// <summary>
    /// <h3 dir="rtl" style="color:red; font-family: Helvetica, Arial, sans-serif">
    ///    -       .
    /// </h3>
    /// </summary>
    /// <author>   ,   ,  ,  </author>
    /// <version> 12.11.2007 </version>
    /// <typeparam name="T">    </typeparam>
    public class List<T>
    {
        private Node<T> first;

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///    
        /// </b>
        /// </summary>
        public List()
        {
            this.first = null;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///         ;   ,   null
        /// </b>
        /// </summary>
        /// <returns>    </returns>
        public Node<T> GetFirst()
        {
            return (this.first);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///       x     pos;
        ///  pos  null,  x    ;
        ///        . 
        /// <br/>
        /// <u>:</u> pos       null
        /// </b>
        /// </summary>
        /// <param name="pos">      </param>
        /// <param name="x">   </param>
        /// <returns>     </returns>
        public Node<T> Insert(Node<T> pos, T x)
        {
            Node<T> node = new Node<T>(x);

            if (pos == null)
            {
                node.SetNext(this.first);
                this.first = node;
            }
            else
            {
                node.SetNext(pos.GetNext());
                pos.SetNext(node);
            }
            return (node);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///         pos,     -pos; 
        ///     -  null
        /// <br/>
        /// <u>:</u> pos      null.
        /// </b>
        /// </summary>
        /// <param name="pos">    </param>
        /// <returns>    pos </returns>
        public Node<T> Remove(Node<T> pos)
        {
            if (this.first == pos)
                this.first = pos.GetNext();
            else
            {
                Node<T> prevPos = this.GetFirst();
                while (prevPos.GetNext() != pos)
                    prevPos = prevPos.GetNext();
                prevPos.SetNext(pos.GetNext());
            }

            Node<T> nextPos = pos.GetNext();
            pos.SetNext(null);

            return nextPos;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///   ''    , '' 
        /// </b>
        /// </summary>
        /// <returns> ``    , ``  </returns>
        public bool IsEmpty()
        {
            return (this.first == null);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///     ,   ,  (x1    ):
        /// [x1,x2,...,xn]
        /// </b>
        /// </summary>
        /// <returns>     </returns>
        public override string ToString()
        {
            string str = "[";
            Node<T> pos = this.first;
            while (pos != null)
            {
                str = str + pos.GetInfo().ToString();
                if (pos.GetNext() != null)
                    str = str + ",";
                pos = pos.GetNext();
            }
            str = str + "]";

            return (str);
        }
    }	
}
